diff --git a/src/include/nodes/nodes.h b/src/include/nodes/nodes.h
index cb9307c..e2a3716 100644
--- a/src/include/nodes/nodes.h
+++ b/src/include/nodes/nodes.h
@@ -61,6 +61,7 @@ typedef enum NodeTag
 	T_FunctionScan,
 	T_ValuesScan,
 	T_CteScan,
+	T_SpiRelationScan,
 	T_WorkTableScan,
 	T_ForeignScan,
 	T_CustomScan,
@@ -109,6 +110,7 @@ typedef enum NodeTag
 	T_FunctionScanState,
 	T_ValuesScanState,
 	T_CteScanState,
+	T_SpiRelationScanState,
 	T_WorkTableScanState,
 	T_ForeignScanState,
 	T_CustomScanState,
diff --git a/src/include/nodes/params.h b/src/include/nodes/params.h
index a8aa530..2d66292 100644
--- a/src/include/nodes/params.h
+++ b/src/include/nodes/params.h
@@ -17,6 +17,7 @@
 /* Forward declarations, to avoid including other headers */
 struct Bitmapset;
 struct ParseState;
+struct EState;
 
 
 /* ----------------
diff --git a/src/include/nodes/parsenodes.h b/src/include/nodes/parsenodes.h
index 04b1c2f..51d2d14 100644
--- a/src/include/nodes/parsenodes.h
+++ b/src/include/nodes/parsenodes.h
@@ -791,7 +791,8 @@ typedef enum RTEKind
 	RTE_JOIN,					/* join */
 	RTE_FUNCTION,				/* function in FROM */
 	RTE_VALUES,					/* VALUES (<exprlist>), (<exprlist>), ... */
-	RTE_CTE						/* common table expr (WITH list element) */
+	RTE_CTE,					/* common table expr (WITH list element) */
+	RTE_SPIRELATION				/* relation supplied via SPI */
 } RTEKind;
 
 typedef struct RangeTblEntry
@@ -867,6 +868,15 @@ typedef struct RangeTblEntry
 	List	   *ctecolcollations;		/* OID list of column collation OIDs */
 
 	/*
+	 * Needed for SPI relation RTE...
+	 *
+	 * ... include the cte* List fields from CTE and relid.  We could
+	 * duplicate them here with slightly different names, but why?
+	 */
+	char	   *srname;			/* name by which relation will be referenced */
+	int			srtuples;		/* estimated number of rows */
+
+	/*
 	 * Fields valid in all RTEs:
 	 */
 	Alias	   *alias;			/* user-written alias clause, if any */
diff --git a/src/include/nodes/plannodes.h b/src/include/nodes/plannodes.h
index e2fbc7d..1bcbcab 100644
--- a/src/include/nodes/plannodes.h
+++ b/src/include/nodes/plannodes.h
@@ -487,6 +487,16 @@ typedef struct CteScan
 } CteScan;
 
 /* ----------------
+ *		SpiRelationScan node
+ * ----------------
+ */
+typedef struct SpiRelationScan
+{
+	Scan		scan;
+	char	   *srname;
+} SpiRelationScan;
+
+/* ----------------
  *		WorkTableScan node
  * ----------------
  */
diff --git a/src/include/optimizer/cost.h b/src/include/optimizer/cost.h
index 2a4df2f..78722cb 100644
--- a/src/include/optimizer/cost.h
+++ b/src/include/optimizer/cost.h
@@ -93,6 +93,8 @@ extern void cost_valuesscan(Path *path, PlannerInfo *root,
 				RelOptInfo *baserel, ParamPathInfo *param_info);
 extern void cost_ctescan(Path *path, PlannerInfo *root,
 			 RelOptInfo *baserel, ParamPathInfo *param_info);
+extern void cost_spirelationscan(Path *path, PlannerInfo *root,
+			 RelOptInfo *baserel, ParamPathInfo *param_info);
 extern void cost_recursive_union(Path *runion, Path *nrterm, Path *rterm);
 extern void cost_sort(Path *path, PlannerInfo *root,
 		  List *pathkeys, Cost input_cost, double tuples, int width,
@@ -181,6 +183,7 @@ extern void set_function_size_estimates(PlannerInfo *root, RelOptInfo *rel);
 extern void set_values_size_estimates(PlannerInfo *root, RelOptInfo *rel);
 extern void set_cte_size_estimates(PlannerInfo *root, RelOptInfo *rel,
 					   double cte_rows);
+extern void set_spirelation_size_estimates(PlannerInfo *root, RelOptInfo *rel);
 extern void set_foreign_size_estimates(PlannerInfo *root, RelOptInfo *rel);
 extern PathTarget *set_pathtarget_cost_width(PlannerInfo *root, PathTarget *target);
 
diff --git a/src/include/optimizer/pathnode.h b/src/include/optimizer/pathnode.h
index 71d9154..14fbfe2 100644
--- a/src/include/optimizer/pathnode.h
+++ b/src/include/optimizer/pathnode.h
@@ -85,6 +85,8 @@ extern Path *create_valuesscan_path(PlannerInfo *root, RelOptInfo *rel,
 					   Relids required_outer);
 extern Path *create_ctescan_path(PlannerInfo *root, RelOptInfo *rel,
 					Relids required_outer);
+extern Path *create_spirelationscan_path(PlannerInfo *root, RelOptInfo *rel,
+					Relids required_outer);
 extern Path *create_worktablescan_path(PlannerInfo *root, RelOptInfo *rel,
 						  Relids required_outer);
 extern ForeignPath *create_foreignscan_path(PlannerInfo *root, RelOptInfo *rel,
diff --git a/src/include/parser/analyze.h b/src/include/parser/analyze.h
index 5ba322a..e76b4a3 100644
--- a/src/include/parser/analyze.h
+++ b/src/include/parser/analyze.h
@@ -23,9 +23,11 @@ extern PGDLLIMPORT post_parse_analyze_hook_type post_parse_analyze_hook;
 
 
 extern Query *parse_analyze(Node *parseTree, const char *sourceText,
-			  Oid *paramTypes, int numParams);
+			   Oid *paramTypes, int numParams,
+			   QueryEnvironment *queryEnv);
 extern Query *parse_analyze_varparams(Node *parseTree, const char *sourceText,
-						Oid **paramTypes, int *numParams);
+						Oid **paramTypes, int *numParams,
+						QueryEnvironment *queryEnv);
 
 extern Query *parse_sub_analyze(Node *parseTree, ParseState *parentParseState,
 				  CommonTableExpr *parentCTE,
diff --git a/src/include/parser/parse_node.h b/src/include/parser/parse_node.h
index 6633586..5cd0330 100644
--- a/src/include/parser/parse_node.h
+++ b/src/include/parser/parse_node.h
@@ -15,6 +15,7 @@
 #define PARSE_NODE_H
 
 #include "nodes/parsenodes.h"
+#include "parser/query_environment.h"
 #include "utils/relcache.h"
 
 
@@ -68,6 +69,7 @@ typedef enum ParseExprKind
 } ParseExprKind;
 
 
+
 /*
  * Function signatures for parser hooks
  */
@@ -80,7 +82,6 @@ typedef Node *(*CoerceParamHook) (ParseState *pstate, Param *param,
 									   Oid targetTypeId, int32 targetTypeMod,
 											  int location);
 
-
 /*
  * State information used during parse analysis
  *
@@ -142,6 +143,7 @@ struct ParseState
 	List	   *p_ctenamespace; /* current namespace for common table exprs */
 	List	   *p_future_ctes;	/* common table exprs not yet in namespace */
 	CommonTableExpr *p_parent_cte;		/* this query's containing CTE */
+	List	   *p_spirelationnamespace;	/* SPI relations */
 	List	   *p_windowdefs;	/* raw representations of window clauses */
 	ParseExprKind p_expr_kind;	/* what kind of expression we're parsing */
 	int			p_next_resno;	/* next targetlist resno to assign */
diff --git a/src/include/parser/parse_relation.h b/src/include/parser/parse_relation.h
index 3ef3d7b..df56efd 100644
--- a/src/include/parser/parse_relation.h
+++ b/src/include/parser/parse_relation.h
@@ -15,6 +15,7 @@
 #define PARSE_RELATION_H
 
 #include "parser/parse_node.h"
+#include "parser/query_environment.h"
 
 
 /*
@@ -42,6 +43,8 @@ extern RangeTblEntry *refnameRangeTblEntry(ParseState *pstate,
 extern CommonTableExpr *scanNameSpaceForCTE(ParseState *pstate,
 					const char *refname,
 					Index *ctelevelsup);
+extern SpiRelation *scanNameSpaceForSpiRelation(ParseState *pstate,
+												const char *refname);
 extern void checkNameSpaceConflicts(ParseState *pstate, List *namespace1,
 						List *namespace2);
 extern int RTERangeTablePosn(ParseState *pstate,
@@ -71,6 +74,10 @@ extern RangeTblEntry *addRangeTableEntryForRelation(ParseState *pstate,
 							  Alias *alias,
 							  bool inh,
 							  bool inFromCl);
+extern RangeTblEntry *addRangeTableEntryForSpiRelation(ParseState *pstate,
+							SpiRelation *sr,
+							RangeVar *rv,
+							bool inFromCl);
 extern RangeTblEntry *addRangeTableEntryForSubquery(ParseState *pstate,
 							  Query *subquery,
 							  Alias *alias,
diff --git a/src/include/parser/query_environment.h b/src/include/parser/query_environment.h
new file mode 100644
index 0000000..70fa49f
--- /dev/null
+++ b/src/include/parser/query_environment.h
@@ -0,0 +1,41 @@
+/*-------------------------------------------------------------------------
+ *
+ * query_environment.h
+ *
+ * Portions Copyright (c) 1996-2016, PostgreSQL Global Development Group
+ *
+ * src/include/parser/query_environment.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef QUERY_ENVIRONMENT_H
+#define QUERY_ENVIRONMENT_H
+
+#include "access/tupdesc.h"
+#include "nodes/pg_list.h"
+
+struct Tuplestorestate;
+
+/*
+ * A relation that SPI client code has exposed to the parser, planner and
+ * executor.
+ */
+typedef struct SpiRelation
+{
+	char	   *name;			/* Name of the relation */
+	TupleDesc	tupdesc;		/* Descriptor for tuples */
+	int			tuples;			/* Estimated number of tuples. */
+	struct Tuplestorestate *tuplestore;	/* The tuples. */
+} SpiRelation;
+
+/*
+ * Users of the SPI interface such as PLs can make transient database objects
+ * visible to the SQL parser, planner and executor.  Currently the only example
+ * is SPI relations.
+ */
+typedef struct QueryEnvironment
+{
+	List *spi_relations;		/* A list of pointers to SpiRelation */
+} QueryEnvironment;
+
+#endif   /* QUERY_ENVIRONMENT_H */
diff --git a/src/include/tcop/tcopprot.h b/src/include/tcop/tcopprot.h
index 7254355..07935b9 100644
--- a/src/include/tcop/tcopprot.h
+++ b/src/include/tcop/tcopprot.h
@@ -22,6 +22,7 @@
 #include "nodes/params.h"
 #include "nodes/parsenodes.h"
 #include "nodes/plannodes.h"
+#include "parser/query_environment.h"
 #include "storage/procsignal.h"
 #include "utils/guc.h"
 
@@ -48,11 +49,13 @@ extern int	log_statement;
 
 extern List *pg_parse_query(const char *query_string);
 extern List *pg_analyze_and_rewrite(Node *parsetree, const char *query_string,
-					   Oid *paramTypes, int numParams);
+					   Oid *paramTypes, int numParams,
+					   QueryEnvironment *queryEnv);
 extern List *pg_analyze_and_rewrite_params(Node *parsetree,
 							  const char *query_string,
 							  ParserSetupHook parserSetup,
-							  void *parserSetupArg);
+							  void *parserSetupArg,
+							  QueryEnvironment *queryEnv);
 extern PlannedStmt *pg_plan_query(Query *querytree, int cursorOptions,
 			  ParamListInfo boundParams);
 extern List *pg_plan_queries(List *querytrees, int cursorOptions,
diff --git a/src/include/tcop/utility.h b/src/include/tcop/utility.h
index dad8246..1b8589c 100644
--- a/src/include/tcop/utility.h
+++ b/src/include/tcop/utility.h
@@ -27,14 +27,17 @@ typedef enum
 typedef void (*ProcessUtility_hook_type) (Node *parsetree,
 					  const char *queryString, ProcessUtilityContext context,
 													  ParamListInfo params,
+									QueryEnvironment *queryEnv,
 									DestReceiver *dest, char *completionTag);
 extern PGDLLIMPORT ProcessUtility_hook_type ProcessUtility_hook;
 
 extern void ProcessUtility(Node *parsetree, const char *queryString,
 			   ProcessUtilityContext context, ParamListInfo params,
+			   QueryEnvironment *queryEnv,
 			   DestReceiver *dest, char *completionTag);
 extern void standard_ProcessUtility(Node *parsetree, const char *queryString,
 						ProcessUtilityContext context, ParamListInfo params,
+						QueryEnvironment *queryEnv,
 						DestReceiver *dest, char *completionTag);
 
 extern bool UtilityReturnsTuples(Node *parsetree);
diff --git a/src/include/utils/portal.h b/src/include/utils/portal.h
index c1d93a9..7b38af2 100644
--- a/src/include/utils/portal.h
+++ b/src/include/utils/portal.h
@@ -137,6 +137,7 @@ typedef struct PortalData
 	CachedPlan *cplan;			/* CachedPlan, if stmts are from one */
 
 	ParamListInfo portalParams; /* params to pass to query */
+	QueryEnvironment *queryEnv; /* transient objects introduced by SPI */
 
 	/* Features/options */
 	PortalStrategy strategy;	/* see above */
